import { reactive as A, defineComponent as wl, getCurrentInstance as Pl, ref as m, computed as z, onMounted as Vl, watchEffect as Bl, toRefs as xl, resolveComponent as b, resolveDirective as Se, openBlock as c, createBlock as f, normalizeStyle as Hl, unref as L, withCtx as n, createVNode as r, withDirectives as W, createElementVNode as de, renderSlot as S, withKeys as Ae, createElementBlock as M, Fragment as k, renderList as Z, mergeProps as H, createCommentVNode as $, vShow as Sl, createTextVNode as R, toDisplayString as ce, createSlots as Me, resolveDynamicComponent as Al, normalizeProps as Ml, guardReactiveProps as kl } from "vue";
import { ElNotification as Ul, ElMessage as ke, ElMessageBox as _e } from "element-plus";
import { useRoute as Rl } from "vue-router";
const j = {
  beforeSubmitHandler: "beforeSubmitHandler",
  beforedisabledHandler: "beforedisabledHandler",
  afterdisabledHandler: "afterdisabledHandler",
  beforeAddHandler: "beforeAddHandler",
  beforeEditHandler: "beforeEditHandler",
  beforeQueryHandler: "beforeQueryHandler",
  afterQueryHandler: "afterQueryHandler",
  beforeDeteleHandler: "beforeDeteleHandler",
  afterDeteleHandler: "afterDeteleHandler",
  beforeTableLazyHandler: "beforeTableLazyHandler"
};
function Nl(u = { debug: !1 }) {
  const p = A({
    hooks: {}
  });
  return Object.keys(u).forEach((t) => {
    t !== "debug" && (p.hooks[t] = u[t]);
  }), {
    hookHandler: (t, B) => {
      let D = !1;
      try {
        u.debug && (console.group("DeBug\uFF1A", t), console.table(B.Data), console.groupEnd()), D = p.hooks[t](B);
      } catch {
        D = !0;
      }
      return D;
    }
  };
}
const ue = (u, p = "success") => {
  Ul({
    title: u,
    type: p,
    offset: 70,
    duration: 2500
  });
};
function U(u) {
  let p;
  try {
    p = Array.isArray(u) ? [] : {}, u === null && (p = null);
  } catch {
    p = {};
  }
  for (const g in u)
    typeof u[g] == "object" ? p[g] = U(u[g]) : p[g] = u[g];
  return p;
}
function ie(u, p) {
  let g = U(u);
  for (var t in p)
    g.hasOwnProperty(t) && typeof p[t] == "object" ? g[t] = ie(g[t], p[t]) : g[t] = p[t];
  return g;
}
function zl(u, p) {
  let g = {}, t = Object.getOwnPropertyNames(u), B = Object.getOwnPropertyNames(p);
  return t.length === B.length && t.forEach((D) => {
    u[D] !== p[D] && (g[D] = p[D]);
  }), g;
}
const $l = {
  debug: !1,
  IssearchForm: !0,
  labelWidth: 120,
  expand: !0,
  menuWidth: 310,
  menuAlign: "left",
  dialogWidth: 800,
  editFooterButton: !0,
  pageSizes: [10, 20, 50, 100],
  Pagination: {
    current: 1,
    pageSize: 10,
    total: 0
  },
  PaginationLayout: "->,total, sizes, prev, pager, next, jumper",
  queryAfterMount: !1,
  openMultipleSelection: !1,
  openIndex: !0,
  autoProcessUpload: !0,
  destroyOnClosModal: !0,
  apiName: {
    query: "query",
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  permission: {
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  permissions: ["add", "edit", "delete", "deleteFlag", "remove"]
};
let V = A({});
function O(...u) {
  V.debug && console.info("%c\u3010DeBug\u3011", "color:red", ...u);
}
const Ue = (u) => {
  V = ie($l, u);
};
Ue({});
const Ol = /* @__PURE__ */ R(" \u65B0\u589E "), Kl = /* @__PURE__ */ R(" \u6279\u91CF\u5220\u9664 "), Il = { class: "quick-search-area" }, Tl = { style: { display: "flex", "justify-content": "flex-end" } }, ql = /* @__PURE__ */ R("\u53D6\u6D88"), Ll = /* @__PURE__ */ R("\u91CD\u7F6E"), Wl = /* @__PURE__ */ R("\u63D0\u4EA4"), jl = /* @__PURE__ */ wl({
  __name: "index",
  props: {
    url: null,
    source: null,
    rowKey: null,
    rowKeys: null,
    keyName: null,
    AddInitID: null,
    watchData: null,
    hooks: null,
    wrapperStyle: null,
    tableHeight: null,
    queryAfterMount: { type: Boolean, default: () => V.queryAfterMount },
    openMultipleSelection: { type: Boolean, default: () => V.openMultipleSelection },
    openIndex: { type: Boolean, default: () => V.openIndex },
    expand: { type: Boolean, default: () => V.expand },
    PaginationLayout: { default: () => V.PaginationLayout },
    fullscreen: { type: Boolean },
    destroyOnClosModal: { type: Boolean, default: () => V.destroyOnClosModal },
    dialogWidth: { default: () => V.dialogWidth },
    autoProcessUpload: { type: Boolean, default: () => V.autoProcessUpload },
    closeOnPressEscape: { type: Boolean },
    editFooterButton: { type: Boolean, default: () => V.editFooterButton },
    permission: { default: () => V.permissions }
  },
  emits: ["update:modelValue", "cell-click", "row-contextmenu"],
  setup(u, { expose: p, emit: g }) {
    const t = u;
    O("\u521D\u59CB\u5316\u540E\u7684\u3010\u7CFB\u7EDF\u53C2\u6570\u3011", V), O("\u3010Props\u53C2\u6570\u3011", t);
    const B = Pl(), D = Rl(), K = m(), pe = m(), Ee = m(), fe = m(), Q = m("add"), I = m(!1), ee = m(!1), N = m(!1), Re = m(t.editFooterButton), v = A({ ...ie(V, t.source.options) }), { hookHandler: T } = Nl(t.hooks);
    let q = z(() => v.CrudRequest);
    const E = m({ filter: {}, editor: {}, column: {} }), Ne = m(), Ce = m(), De = m(), ve = m(), we = m(), F = m({}), le = m({}), y = m({}), me = m({}), ae = m([]), ze = m([]), w = A({
      current: v.Pagination.current,
      pageSize: v.Pagination.pageSize,
      total: v.Pagination.total
    }), J = m(0), be = m(0), ge = m(0), oe = m(0);
    if ((() => {
      const { filter: l, editor: a, column: o, columns: d } = t.source;
      let C = {};
      l.forEach((_) => {
        d[_].searchDefaultValue !== void 0 ? C[_] = d[_].searchDefaultValue : C[_] = void 0, E.value.filter[_] = d[_];
      }), ve.value = U(C), F.value = U(ve.value);
      let Y = {};
      a.forEach((_) => {
        d[_].addDefaultValue !== void 0 ? Y[_] = d[_].addDefaultValue : Y[_] = void 0, E.value.editor[_] = d[_];
      }), we.value = U(Y), o.forEach((_) => {
        E.value.column[_] = d[_];
      }), Ne.value = d;
    })(), D.params.data) {
      O("\u8DEF\u7531\u4F20\u53C2\uFF1A", D.params.data);
      let l = D.params.data, a = JSON.parse(l);
      le.value = ie(le.value, a), O("searchFormValue", le);
    }
    const $e = z(() => {
      let l = {};
      const a = ["el-input", "el-input-number", "el-select", "el-date-picker"];
      return t.source.filter.forEach((o) => {
        a.includes(E.value.filter[o].type) && (l[o] = E.value.filter[o]);
      }), l;
    }), Oe = z(() => {
      let l = {};
      const a = ["el-input", "el-input-number", "el-select", "el-date-picker", "el-cascader", "el-upload"];
      return t.source.editor.forEach((o) => {
        a.includes(E.value.editor[o].type) && G(E.value.editor[o], "visible") && (l[o] = E.value.editor[o]);
      }), l;
    }), Ke = z(() => ({ ...t.wrapperStyle })), Ie = z(() => (w.current - 1) * w.pageSize + 1), Te = z(() => {
      const l = m(0);
      return t.tableHeight ? l.value = t.tableHeight : v.IssearchForm ? l.value = be.value : l.value = ge.value, l.value;
    }), Pe = z(() => t.fullscreen ? oe.value - 50 : oe.value > 250 ? oe.value - J.value * 0.3 : 250);
    Vl(() => {
      J.value = document.documentElement.clientHeight, be.value = J.value - 50 - 20 - 40 - 56 - pe.value.clientHeight - K.value.clientHeight, ge.value = J.value - 50 - 20 - 40 - 56 - pe.value.clientHeight, oe.value = J.value - 54 - 62, t.queryAfterMount && P(), t.watchData && t.watchData.forEach((l) => {
        Bl(() => {
          y.value[l.id] && (O("\u76D1\u542C\u7684id\u6570\u636E", y.value[l.id]), l.data.forEach((a) => {
            a.data[l.id] = y.value[l.id], O("\u76D1\u542C\u7684\u6570\u636E\u8BF7\u6C42", a), el(a);
          }));
        });
      }), O("onMounted", h), O("Hight", { clientHeight: J, OpenSearchFormtableMaxHeight: be, CloseSearchFormtableMaxHeight: ge, EditFormMaxHeight: oe });
    });
    const he = (l) => {
      let a = {};
      return t.rowKey && (a[t.rowKey] = l[t.rowKey]), t.rowKeys && t.rowKeys.forEach((o) => {
        a[o] = l[o];
      }), a;
    }, re = (l) => l.formProps && l.formProps.type ? l.range ? l.formProps.type + "range" : l.formProps.type : "date", G = (l, a) => {
      if (a === "disabled")
        return typeof l.disabled == "function" ? l.disabled(h, Q.value) : !1;
      if (a === "visible")
        return typeof l.visible == "function" ? l.visible(h, Q.value) : !0;
    }, qe = (l, a, o, d) => {
      g("cell-click", { row: l, column: a, cell: o, event: d });
    }, Le = (l, a, o, d) => {
      navigator.clipboard.writeText(o.innerText).then(() => {
        ke.success("\u590D\u5236\u6210\u529F\uFF01");
      });
    }, We = (l, a, o) => {
      g("row-contextmenu", { row: l, column: a, event: o }, h);
    }, je = (l) => {
      ae.value = l;
    }, Qe = (l) => {
      let a = { ...l };
      return Object.keys(a).forEach((o) => {
        typeof a[o] == "function" && (a[o] = a[o].bind(this, h));
      }), a;
    }, Je = (l, a) => {
      let o = { ...l };
      return Object.keys(o).forEach((d) => {
        typeof o[d] == "function" && (o[d] = o[d].call(this, h, a));
      }), o;
    }, Ge = (l) => {
      w.pageSize = l, P();
    }, Xe = (l) => {
      w.current = l, w.current != null && P();
    }, Ye = (l, a, o) => {
      if (a.type === "el-select") {
        const d = a.formProps.options.findIndex((C) => C.value == l.row[o]);
        return d === -1 ? l.row[o] : a.formProps.options[d].label;
      } else
        return l.row[o];
    }, Ze = () => {
      X.value.length && X.value.forEach((l) => {
        E.value.editor[l].formProps.fileList = [];
      });
    }, X = z(() => {
      let l = [];
      for (const a in E.value.editor)
        if (Object.prototype.hasOwnProperty.call(E.value.editor, a)) {
          const o = E.value.editor[a];
          o.type === "el-upload" && o.formProps.hasOwnProperty("listType") && o.formProps.listType === "picture-card" && l.push(a);
        }
      return l;
    }), el = (l) => {
      q.value({ url: l.url, name: l.name, data: l.data }).then((a) => {
        E.value.editor[l.key].formProps.options = a.data.map((o) => {
          if (typeof l.label == "string")
            return {
              value: o[l.value],
              label: o[l.label]
            };
          if (typeof l.label == "object")
            return {
              value: o[l.value],
              label: o[l.label[0]] + "--" + o[l.label[1]]
            };
        });
      });
    }, P = () => {
      ee.value = !0;
      const l = A({
        ...F.value,
        ...le.value
      });
      for (const a in l)
        Object.prototype.hasOwnProperty.call(l, a) && typeof l[a] == "string" && (l[a] = l[a].trim(), l[a] === "" && (l[a] = void 0));
      !T(j.beforeQueryHandler, { CrudState: h, Data: l }) || q.value({
        url: t.url,
        name: v.apiName.query,
        data: {
          pagenum: w.current,
          pagesize: w.pageSize,
          ...l
        }
      }).then((a) => {
        const { data: o, page: d } = a;
        setTimeout(() => {
          ll(o, l), w.total = d.total, ee.value = !1;
        }, 50);
      }).catch(() => {
        ee.value = !1;
      });
    }, ll = (l, a) => {
      Object.keys(a).filter((d) => a[d] != null).length == 0 && (De.value = l), De.value = U(l), T(j.afterQueryHandler, { CrudState: h, Data: l }) && (Ce.value = U(l));
    }, al = () => {
      F.value = U(ve.value), P();
    }, ol = (l) => {
      !l || (l.resetFields(), X.value.length && X.value.forEach((a) => {
        const o = a + "UploadRef";
        (B == null ? void 0 : B.refs[o])[0].clearFiles();
      }));
    }, tl = () => {
      y.value = U(we.value);
      const l = A({ ...y.value });
      !T(j.beforeAddHandler, { CrudState: h, Data: l }) || (Q.value = "add", I.value = !0);
    }, nl = (l) => {
      const a = A({
        ...l
      });
      t.autoProcessUpload && X.value.length && X.value.forEach((o) => {
        E.value.editor[o].formProps.fileList = a.imageList.map((d) => ({ url: d }));
      }), T(j.beforeEditHandler, { CrudState: h, Data: a }) && (Object.keys(a).forEach((o) => {
        y.value[o] = a[o], me.value[o] = a[o];
      }), Q.value = "edit", I.value = !0);
    }, se = async (l) => {
      !l || await l.validate((a) => {
        if (a) {
          const o = A({
            ...y.value
          });
          if (!T(j.beforeSubmitHandler, { CrudState: h, Data: o }))
            return;
          h.Mode === "add" ? ul(o) : rl(o);
        }
      });
    }, ul = (l) => {
      N.value = !0;
      let a = l;
      l.FormData instanceof FormData && (a = l.FormData), q.value({ url: t.url, name: v.apiName.add, data: a }).then(() => {
        I.value = !1, ue("\u65B0\u589E\u6210\u529F"), P(), N.value = !1;
      }).catch(() => {
        N.value = !1;
      });
    }, rl = (l) => {
      N.value = !0;
      let a = l;
      if (l.FormData instanceof FormData)
        a = l.FormData;
      else {
        const o = zl(me.value, a);
        if (JSON.stringify(o) === "{}")
          return N.value = !1, ke({ message: "\u6CA1\u6709\u63D0\u4EA4\u9879\uFF01", grouping: !0 });
        a = {
          ...he(l),
          ...o
        };
      }
      q.value({ url: t.url, name: v.apiName.edit, data: a }).then(() => {
        I.value = !1, ue("\u4FEE\u6539\u6210\u529F"), P(), N.value = !1;
      }).catch(() => {
        N.value = !1;
      });
    }, sl = (l) => {
      _e.confirm(`\u786E\u5B9A\u8981 \u201C${l.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u201D \u8BE5\u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const a = A({
          row: { ...l },
          ...he(l),
          deleteFlag: l.deleteFlag == 0 ? 1 : 0
        });
        !T(j.beforedisabledHandler, { CrudState: h, Data: a }) || q.value({
          url: t.url,
          name: v.apiName.deleteFlag,
          data: a
        }).then(() => {
          ue(`\u6570\u636E${l.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u6210\u529F`), P();
        });
      }).catch(() => {
      });
    }, dl = (l) => {
      _e.confirm("\u786E\u5B9A\u8981\u5220\u9664\u672C\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const a = A({
          row: { ...l },
          ...he(l)
        });
        !T(j.beforeDeteleHandler, { CrudState: h, Data: a }) || q.value({
          url: t.url,
          name: v.apiName.delete,
          data: a
        }).then(() => {
          ue("\u5220\u9664\u6210\u529F"), P();
        });
      }).catch(() => {
      });
    }, cl = () => {
      _e.confirm("\u786E\u5B9A\u8981\u5220\u9664\u8FD9\u51E0\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const l = ae.value.map((a) => a[t.rowKey]);
        q.value({
          url: t.url,
          name: v.apiName.remove,
          data: { [t.rowKey]: l, selection: ae.value }
        }).then(() => {
          ue("\u6279\u91CF\u5220\u9664\u6210\u529F"), ae.value = [], Ee.value.clearSelection(), P();
        });
      }).catch(() => {
      });
    }, h = A({
      ElementArrs: E,
      searchModel: F,
      searchFormValue: le,
      editModel: y,
      editFormValue: me,
      uploadFiles: ze,
      tableLoading: ee,
      Pagination: w,
      Mode: Q,
      queryRecord: P
    });
    return p({
      ...xl(h)
    }), (l, a) => {
      const o = b("el-input"), d = b("el-form-item"), C = b("el-col"), Y = b("el-input-number"), _ = b("el-option"), Ve = b("el-select"), ye = b("el-date-picker"), Be = b("el-row"), xe = b("el-form"), il = b("el-collapse-transition"), x = b("el-button"), pl = b("el-empty"), te = b("el-table-column"), fl = b("el-descriptions-item"), vl = b("el-descriptions"), ml = b("el-button-group"), bl = b("el-table"), gl = b("el-pagination"), hl = b("el-cascader"), yl = b("plus"), _l = b("el-icon"), Fl = b("el-upload"), El = b("el-scrollbar"), He = b("el-card"), Cl = b("el-dialog"), ne = Se("permission"), Dl = Se("loading");
      return c(), f(He, {
        style: Hl([{ border: "0" }, L(Ke)])
      }, {
        default: n(() => [
          r(il, null, {
            default: n(() => [
              W(de("div", {
                id: "plain",
                ref_key: "searchFormRef",
                ref: K
              }, [
                S(l.$slots, "search-form", {
                  editModel: F.value,
                  queryRecord: P,
                  CrudState: h
                }, void 0, !0),
                r(xe, {
                  model: F.value,
                  "label-width": v.labelWidth,
                  onKeyup: Ae(P, ["enter", "native"])
                }, {
                  default: n(() => [
                    r(Be, null, {
                      default: n(() => [
                        S(l.$slots, "search-form-top", { CrudState: h }, void 0, !0),
                        (c(!0), M(k, null, Z(L($e), (e, s) => (c(), M(k, null, [
                          e.type === "el-input" ? (c(), f(C, {
                            key: 0,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: n(() => [
                              r(d, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  r(o, H({
                                    style: { width: "100%" },
                                    modelValue: F.value[s],
                                    "onUpdate:modelValue": (i) => F.value[s] = i,
                                    clearable: "",
                                    placeholder: "\u6A21\u7CCA\u67E5\u627E"
                                  }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-input-number" ? (c(), f(C, {
                            key: 1,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: n(() => [
                              r(d, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  r(Y, H({
                                    style: { width: "100%" },
                                    modelValue: F.value[s],
                                    "onUpdate:modelValue": (i) => F.value[s] = i,
                                    placeholder: "\u8BF7\u8F93\u5165"
                                  }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-select" ? (c(), f(C, {
                            key: 2,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: n(() => [
                              r(d, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  r(Ve, H({
                                    style: { width: "100%" },
                                    modelValue: F.value[s],
                                    "onUpdate:modelValue": (i) => F.value[s] = i,
                                    clearable: "",
                                    placeholder: "\u8BF7\u9009\u62E9"
                                  }, e.formProps), {
                                    default: n(() => [
                                      (c(!0), M(k, null, Z(e.formProps.options, (i) => (c(), f(_, {
                                        key: i.value,
                                        label: i.label,
                                        value: i.value
                                      }, null, 8, ["label", "value"]))), 128))
                                    ]),
                                    _: 2
                                  }, 1040, ["modelValue", "onUpdate:modelValue"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-date-picker" && re(e).includes("range") ? (c(), f(C, {
                            key: 3,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 12
                          }, {
                            default: n(() => [
                              r(d, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  r(ye, H({
                                    style: { width: "100%" },
                                    modelValue: F.value[s],
                                    "onUpdate:modelValue": (i) => F.value[s] = i,
                                    "start-placeholder": "\u8D77\u59CB",
                                    "range-separator": "\u81F3",
                                    "end-placeholder": "\u7ED3\u675F",
                                    placeholder: "\u8BF7\u9009\u62E9",
                                    clearable: ""
                                  }, e.formProps, {
                                    type: re(e)
                                  }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-date-picker" && re(e) ? (c(), f(C, {
                            key: 4,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: n(() => [
                              r(d, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  r(ye, H({
                                    style: { width: "100%" },
                                    modelValue: F.value[s],
                                    "onUpdate:modelValue": (i) => F.value[s] = i,
                                    "start-placeholder": "\u8D77\u59CB",
                                    "range-separator": "\u81F3",
                                    "end-placeholder": "\u7ED3\u675F",
                                    placeholder: "\u8BF7\u9009\u62E9",
                                    clearable: ""
                                  }, e.formProps, {
                                    type: re(e)
                                  }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : $("", !0)
                        ], 64))), 256)),
                        S(l.$slots, "search-form-bottom", { CrudState: h }, void 0, !0)
                      ]),
                      _: 3
                    })
                  ]),
                  _: 3
                }, 8, ["model", "label-width", "onKeyup"])
              ], 512), [
                [Sl, v.IssearchForm]
              ])
            ]),
            _: 3
          }),
          de("div", {
            ref_key: "buttonAreaRef",
            ref: pe,
            class: "button_area"
          }, [
            W((c(), f(x, {
              type: "primary",
              icon: "plus",
              onClick: tl
            }, {
              default: n(() => [
                Ol
              ]),
              _: 1
            })), [
              [ne, { permission: u.permission, access: [v.permission.add] }]
            ]),
            u.openMultipleSelection ? W((c(), f(x, {
              key: 0,
              disabled: ae.value.length <= 0,
              type: "danger",
              icon: "delete",
              onClick: cl
            }, {
              default: n(() => [
                Kl
              ]),
              _: 1
            }, 8, ["disabled"])), [
              [ne, { permission: u.permission, access: [v.permission.remove] }]
            ]) : $("", !0),
            S(l.$slots, "button-area", { CrudState: h }, void 0, !0)
          ], 512),
          W((c(), f(bl, {
            ref_key: "tableRef",
            ref: Ee,
            data: Ce.value,
            "row-key": u.rowKey,
            height: L(Te),
            "show-overflow-tooltip": "",
            onCellClick: qe,
            onCellDblclick: Le,
            onRowContextmenu: We,
            onSelectionChange: je
          }, {
            empty: n(() => [
              r(pl, {
                "image-size": 80,
                description: "\u6682\u65E0\u6570\u636E"
              })
            ]),
            default: n(() => [
              u.openMultipleSelection ? (c(), f(te, {
                key: 0,
                type: "selection",
                width: 44
              })) : $("", !0),
              u.expand ? (c(), f(te, {
                key: 1,
                type: "expand",
                width: 55
              }, {
                default: n((e) => [
                  r(vl, {
                    column: 3,
                    border: ""
                  }, {
                    default: n(() => [
                      (c(!0), M(k, null, Z(u.source.columns, (s, i) => (c(), M(k, { key: i }, [
                        s.hidden ? $("", !0) : (c(), f(fl, {
                          key: 0,
                          label: s.label
                        }, {
                          default: n(() => [
                            R(ce(Ye(e, s, i)), 1)
                          ]),
                          _: 2
                        }, 1032, ["label"]))
                      ], 64))), 128))
                    ]),
                    _: 2
                  }, 1024)
                ]),
                _: 1
              })) : $("", !0),
              u.openIndex ? (c(), f(te, {
                key: 2,
                label: "###",
                width: 55,
                "show-overflow-tooltip": ""
              }, {
                default: n(({ row: e, column: s, $index: i }) => [
                  R(ce(L(Ie) + i), 1)
                ]),
                _: 1
              })) : $("", !0),
              (c(!0), M(k, null, Z(E.value.column, (e, s) => (c(), f(te, H({
                key: s,
                align: e.align || "left"
              }, e.tableProps, {
                label: e.label,
                prop: s,
                "show-overflow-tooltip": ""
              }), Me({ _: 2 }, [
                e.columnSlot ? {
                  name: "default",
                  fn: n((i) => [
                    (c(), f(Al(e.columnSlot.is), Ml(kl(Je(e.columnSlot, i))), null, 16))
                  ])
                } : void 0
              ]), 1040, ["align", "label", "prop"]))), 128)),
              S(l.$slots, "default", {}, void 0, !0),
              r(te, {
                align: v.menuAlign || "left",
                width: t.keyName ? v.menuWidth : v.menuWidth - 150
              }, {
                header: n(() => [
                  de("div", Il, [
                    t.keyName ? (c(), f(o, {
                      key: 0,
                      style: { width: "150px" },
                      modelValue: F.value[t.keyName],
                      "onUpdate:modelValue": a[0] || (a[0] = (e) => F.value[t.keyName] = e),
                      placeholder: E.value.editor[t.keyName].label + "\u6A21\u7CCA\u67E5\u627E",
                      clearable: "",
                      onKeyup: Ae(P, ["enter", "native"])
                    }, null, 8, ["modelValue", "placeholder", "onKeyup"])) : $("", !0),
                    r(ml, null, {
                      default: n(() => [
                        r(x, {
                          color: "#67c23a",
                          icon: "search",
                          onClick: P
                        }),
                        r(x, {
                          color: "#e6a23c",
                          icon: "refresh",
                          onClick: al
                        }),
                        r(x, {
                          color: "#409eff",
                          icon: "expand",
                          onClick: a[1] || (a[1] = (e) => v.IssearchForm = !v.IssearchForm)
                        })
                      ]),
                      _: 1
                    })
                  ])
                ]),
                default: n((e) => [
                  S(l.$slots, "menu-top", { scope: e }, void 0, !0),
                  W((c(), f(x, {
                    plain: "",
                    type: e.row.deleteFlag ? "danger" : "success",
                    onClick: (s) => sl(e.row)
                  }, {
                    default: n(() => [
                      R(ce(e.row.deleteFlag ? "\u7981\u7528" : "\u542F\u7528"), 1)
                    ]),
                    _: 2
                  }, 1032, ["type", "onClick"])), [
                    [ne, { permission: u.permission, access: [v.permission.deleteFlag] }]
                  ]),
                  W(r(x, {
                    plain: "",
                    type: "primary",
                    icon: "edit",
                    onClick: (s) => nl(e.row)
                  }, null, 8, ["onClick"]), [
                    [ne, { permission: u.permission, access: [v.permission.edit] }]
                  ]),
                  W(r(x, {
                    type: "danger",
                    icon: "delete",
                    onClick: (s) => dl(e.row)
                  }, null, 8, ["onClick"]), [
                    [ne, { permission: u.permission, access: [v.permission.delete] }]
                  ]),
                  S(l.$slots, "menu-bottom", { scope: e }, void 0, !0)
                ]),
                _: 3
              }, 8, ["align", "width"])
            ]),
            _: 3
          }, 8, ["data", "row-key", "height"])), [
            [Dl, ee.value]
          ]),
          r(gl, {
            style: { "margin-top": "20px" },
            "hide-on-single-page": "",
            currentPage: w.current,
            "onUpdate:currentPage": a[2] || (a[2] = (e) => w.current = e),
            "page-size": w.pageSize,
            "onUpdate:page-size": a[3] || (a[3] = (e) => w.pageSize = e),
            "page-sizes": v.pageSizes,
            background: "",
            layout: u.PaginationLayout,
            total: w.total,
            onSizeChange: Ge,
            onCurrentChange: Xe
          }, null, 8, ["currentPage", "page-size", "page-sizes", "layout", "total"]),
          r(Cl, {
            "custom-class": "DialogVisible",
            ref: "dialogRef",
            modelValue: I.value,
            "onUpdate:modelValue": a[7] || (a[7] = (e) => I.value = e),
            title: Q.value === "add" ? "\u65B0\u589E" : "\u4FEE\u6539",
            width: v.dialogWidth,
            "destroy-on-close": "",
            fullscreen: u.fullscreen,
            "close-on-click-modal": u.destroyOnClosModal,
            onClosed: Ze
          }, Me({
            default: n(() => [
              r(He, {
                class: "edit-form-card",
                shadow: "never"
              }, {
                default: n(() => [
                  r(El, {
                    height: L(Pe),
                    "max-height": L(Pe)
                  }, {
                    default: n(() => [
                      S(l.$slots, "edit-form", {
                        editModel: y.value,
                        handleSubmit: se,
                        CrudState: h
                      }, void 0, !0),
                      r(xe, {
                        id: "DialogVisible-edit-form",
                        class: "edit-form",
                        ref_key: "editFormRef",
                        ref: fe,
                        model: y.value,
                        "label-width": v.labelWidth
                      }, {
                        default: n(() => [
                          r(Be, null, {
                            default: n(() => [
                              S(l.$slots, "edit-form-top", {
                                editModel: y.value,
                                handleSubmit: se,
                                CrudState: h
                              }, void 0, !0),
                              (c(!0), M(k, null, Z(L(Oe), (e, s) => (c(), M(k, { key: s }, [
                                e.type === "el-input" ? (c(), f(C, {
                                  key: 0,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(d, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(o, H({
                                          style: { width: "100%" },
                                          modelValue: y.value[s],
                                          "onUpdate:modelValue": (i) => y.value[s] = i,
                                          clearable: "",
                                          placeholder: "\u8BF7\u8F93\u5165",
                                          disabled: G(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-input-number" ? (c(), f(C, {
                                  key: 1,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(d, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(Y, H({
                                          style: { width: "100%" },
                                          modelValue: y.value[s],
                                          "onUpdate:modelValue": (i) => y.value[s] = i,
                                          clearable: "",
                                          placeholder: "\u8BF7\u8F93\u5165",
                                          disabled: G(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-select" ? (c(), f(C, {
                                  key: 2,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(d, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(Ve, H({
                                          style: { width: "100%" },
                                          modelValue: y.value[s],
                                          "onUpdate:modelValue": (i) => y.value[s] = i,
                                          clearable: "",
                                          placeholder: "\u8BF7\u9009\u62E9",
                                          disabled: G(e, "disabled")
                                        }, e.formProps), {
                                          default: n(() => [
                                            (c(!0), M(k, null, Z(e.formProps.options, (i) => (c(), f(_, {
                                              key: i.value,
                                              label: i.label,
                                              value: i.value
                                            }, null, 8, ["label", "value"]))), 128))
                                          ]),
                                          _: 2
                                        }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-date-picker" ? (c(), f(C, {
                                  key: 3,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(d, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(ye, H({
                                          style: { width: "100%" },
                                          modelValue: y.value[s],
                                          "onUpdate:modelValue": (i) => y.value[s] = i,
                                          clearable: "",
                                          placeholder: "\u8BF7\u9009\u62E9",
                                          disabled: G(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-cascader" ? (c(), f(C, {
                                  key: 4,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(d, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(hl, H({
                                          style: { width: "100%" },
                                          modelValue: y.value[s],
                                          "onUpdate:modelValue": (i) => y.value[s] = i,
                                          props: e.formProps.props,
                                          placeholder: "\u8BF7\u9009\u62E9",
                                          "show-all-levels": !1,
                                          disabled: G(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "props", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-upload" ? (c(), f(C, {
                                  key: 5,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(d, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(Fl, H({
                                          style: { width: "100%" },
                                          ref_for: !0,
                                          ref: s + "UploadRef",
                                          action: ""
                                        }, Qe(e.formProps)), {
                                          default: n(() => [
                                            e.formProps.listType !== "picture-card" ? (c(), f(x, {
                                              key: 0,
                                              type: "primary"
                                            }, {
                                              default: n(() => [
                                                R(ce(e.formProps.butName || "\u9009\u62E9\u6587\u4EF6"), 1)
                                              ]),
                                              _: 2
                                            }, 1024)) : (c(), f(_l, { key: 1 }, {
                                              default: n(() => [
                                                r(yl)
                                              ]),
                                              _: 1
                                            }))
                                          ]),
                                          _: 2
                                        }, 1040)
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : $("", !0)
                              ], 64))), 128)),
                              S(l.$slots, "edit-form-bottom", {
                                editModel: y.value,
                                handleSubmit: se,
                                CrudState: h
                              }, void 0, !0)
                            ]),
                            _: 3
                          })
                        ]),
                        _: 3
                      }, 8, ["model", "label-width"])
                    ]),
                    _: 3
                  }, 8, ["height", "max-height"])
                ]),
                _: 3
              })
            ]),
            _: 2
          }, [
            Re.value ? {
              name: "footer",
              fn: n(() => [
                de("div", Tl, [
                  S(l.$slots, "edit-form-footer", { CrudState: h }, void 0, !0),
                  r(x, {
                    onClick: a[4] || (a[4] = (e) => I.value = !1)
                  }, {
                    default: n(() => [
                      ql
                    ]),
                    _: 1
                  }),
                  r(x, {
                    type: "warning",
                    plain: "",
                    onClick: a[5] || (a[5] = (e) => ol(fe.value))
                  }, {
                    default: n(() => [
                      Ll
                    ]),
                    _: 1
                  }),
                  r(x, {
                    type: "primary",
                    loading: N.value,
                    onClick: a[6] || (a[6] = (e) => se(fe.value))
                  }, {
                    default: n(() => [
                      Wl
                    ]),
                    _: 1
                  }, 8, ["loading"])
                ])
              ])
            } : void 0
          ]), 1032, ["modelValue", "title", "width", "fullscreen", "close-on-click-modal"])
        ]),
        _: 3
      }, 8, ["style"]);
    };
  }
});
const Ql = (u, p) => {
  const g = u.__vccOpts || u;
  for (const [t, B] of p)
    g[t] = B;
  return g;
}, Fe = /* @__PURE__ */ Ql(jl, [["__scopeId", "data-v-a941cd78"]]), Jl = {
  mounted(u, p, g) {
    const t = p.value.permission, B = p.value.access;
    let D = !1;
    for (let K = 0; K < B.length; K++)
      if (t.includes(B[K])) {
        D = !0;
        break;
      } else
        D = !1;
    D || u.parentNode && u.parentNode.removeChild(u);
  }
};
Fe.install = (u) => {
  u.component("CrudEl", Fe), u.directive("permission", Jl);
};
const Zl = (u, p) => {
  p ? (p.CrudRequest || console.error("\u8BF7\u914D\u7F6E\u5168\u5C40\u8BF7\u6C42\u7684\u4E3B\u65B9\u6CD5\uFF1ACrudRequest"), Ue(p), u.use(Fe)) : console.error("\u8BF7\u521D\u59CB\u5316CrudEl\u914D\u7F6E\u9879");
};
export {
  ie as DataMerger,
  U as DeepClone,
  Ue as InitSys,
  Zl as createCrudEl,
  j as hooksName,
  zl as isObjEqual,
  Nl as useHooks
};
